#include <amxmodx>
#include <fakemeta_util>
#include <fun>
#include <cstrike>
#include <engine>
#include <hamsandwich>
#include <allheroes>
#include <xpsys>


 // Plugin Version
new const PLUGIN_VERSION[] = "0.1"
#define PLUGIN "[AH] Predator"
#define AUTHOR "CLLlAgOB"
// Hero Attributes
new const hclass_name[] = "Predator RED" // name
const hclass_team = 1 // description 1-T 2- CT
new const hclass_skill1[] = "more HP"
new const hclass_skill2[] = "more Plazma"
new const hclass_skill3[] = "power weapon"
new const hclass_model[] = "predatorred" // model
new const hclass_clawmodel[] = "v_knife_predatorred.mdl" // claw model

new const hclass_nameCT[] = "Predator BLUE" // name
const hclass_teamCT = 2 // description 1-T 2- CT
new const hclass_modelCT[] = "predatorblue" // model
new const hclass_clawmodelCT[] = "v_knife_predatorblue.mdl" // claw model

const hclass_health = 350 // health
const hclass_speed = 475 // speed
const Float:hclass_gravity = 0.5 // gravity

// CS Player PData Offsets (win32)
const OFFSET_CSTEAMS = 114
// Linux diff's
const OFFSET_LINUX = 5 // offsets 5 higher in Linux builds
const OFFSET_LINUX_WEAPONS = 4 // weapon offsets are only 4 steps higher on Linux
// CS Weapon CBase Offsets (win32)
const OFFSET_WEAPONOWNER = 41

 //---------------[BODYPARTS STUFF]---------------
new mdl_gib_flesh,mdl_gib_head,mdl_gib_legbone,mdl_gib_lung,mdl_gib_meat,mdl_gib_spine,g_maxplayers,
gTrailModel,gExplosionModel,blood_drop,msgtext,blood_spray,bool:wpn_knife[33],idhero,idheroCT,Float:dmgpred[33]
//CVARS
new CVAR_PLASMA, CVAR_FRAG_PLASMA,
bool:is_alive[33],bool:is_connected[33],bool:is_bot[33],Float:g_last_update_time[33]
#define is_user_valid_connected(%1) (1 <= %1 <= g_maxplayers && is_connected[%1])
new const gWeaponknife [] = "weapon_knife"
//---------------[THE PREDATOR GLOBAL VALUE]---------------

 new bool:ispredator[33]
 new plasma[33]
 new view[33]
 new onoroff[33]
 new Max_Players
 
public plugin_precache()
 {
	register_plugin(PLUGIN, PLUGIN_VERSION, AUTHOR)
	idhero = ah_register_heroes_class(hclass_name, hclass_team, hclass_model, hclass_clawmodel,hclass_skill1,hclass_skill2,hclass_skill3, hclass_health, hclass_speed, hclass_gravity)
	idheroCT = ah_register_heroes_class(hclass_nameCT, hclass_teamCT, hclass_modelCT, hclass_clawmodelCT,hclass_skill1,hclass_skill2,hclass_skill3, hclass_health, hclass_speed, hclass_gravity)	
	precache_model("models/rpgrocket.mdl")
	precache_sound("allheroes/crpredator.wav")
	precache_sound("allheroes/scpredator.wav")
	precache_sound("allheroes/depredator.wav")
	precache_sound("allheroes/plasma_shoot.wav")
	precache_sound("allheroes/explosion.wav")
	precache_model("sprites/plasma.spr")
	gTrailModel = precache_model("sprites/laserbeam.spr")
	gExplosionModel = precache_model("sprites/plasma_explode.spr")
	blood_drop = precache_model("sprites/blood.spr")
	blood_spray = precache_model("sprites/bloodspray.spr")
	mdl_gib_flesh = precache_model("models/Fleshgibs.mdl")
	mdl_gib_head = precache_model("models/GIB_Skull.mdl")
	mdl_gib_legbone = precache_model("models/GIB_Legbone.mdl")
	mdl_gib_lung = precache_model("models/GIB_Lung.mdl")
	mdl_gib_meat = precache_model("models/GIB_B_Gib.mdl")
	mdl_gib_spine = precache_model("models/GIB_B_Bone.mdl")
 }

public plugin_init()
 {
	register_event("WeapPickup", "event_weap_pickup", "be", "1!29") // removes players picked up weapon
	// Get Max Players
	g_maxplayers = get_maxplayers()
	register_event("DeathMsg","death_blood","a")
	register_event("CurWeapon", "toggleclaws", "be", "1=1")
	RegisterHam(Ham_Killed, "player", "fw_PlayerKilled")
	RegisterHam(Ham_Spawn, "player", "fw_PlayerSpawn_Post", 1)
	RegisterHam(Ham_Touch, "weaponbox", "fw_TouchWeapon")
	RegisterHam(Ham_Touch, "armoury_entity", "fw_TouchWeapon")
	RegisterHam(Ham_Touch, "weapon_shield", "fw_TouchWeapon")
	RegisterHam( Ham_Item_Deploy , gWeaponknife, "CSknife_Deploy", 1 );
	register_forward(FM_ClientDisconnect, "fw_ClientDisconnect")
	RegisterHam(Ham_TakeDamage, "player", "player_TakeDamage")
	
	CVAR_PLASMA = register_cvar("pred_plasma_predator","1")
	CVAR_FRAG_PLASMA = register_cvar("pred_frags_plasma","1")
	register_clcmd("pcview","func_view")
	register_touch("PlasmaBall","*","plasma_hit")
	msgtext = get_user_msgid("StatusText")
	Max_Players = get_maxplayers()
 }

// Client joins the game
public client_putinserver(id)
{
	// Player joined
	is_connected[id] = true
	ispredator[id] = false
	g_last_update_time[id] = 0.0
	if (is_user_bot(id))
	{
		is_bot[id] = true
	}
}
// Client leaving
public fw_ClientDisconnect(id)
{
	is_connected[id] = false
	is_bot[id] = false
	is_alive[id] = false
	ispredator[id] = false
	plasma[id] = false
	onoroff[id] = false
}
public fw_PlayerSpawn_Post(id)
{
	// Not alive or didn't join a team yet
	if (!is_user_alive(id) || !fm_cs_get_user_team(id))
		return;
	// Player spawned
	is_alive[id] = true
}
public fw_PlayerKilled(victim, attacker, shouldgib)
{
	// Player killed
	is_alive[victim] = false
	//predatorkill stuff
	if(attacker == victim) return HAM_IGNORED
	new iTeam = get_user_team( attacker )
	if( iTeam != 1 && iTeam != 2 )
		return HAM_IGNORED; 
	if(ispredator[attacker])
	{
		new iOrigin[3]
		if(!ispredator[victim])
		{
			get_user_origin(victim,iOrigin)
			// Effects
			fx_blood_red(iOrigin)
			fx_blood_red(iOrigin)
			fx_blood_red(iOrigin)
			fx_bleed_red(iOrigin)
			fx_bleed_red(iOrigin)
			fx_headshot_red(iOrigin)
			fx_blood_large_red(iOrigin,5)
			fx_blood_small_red(iOrigin,15)
			fx_trans(victim,0)
			fx_gib_explode(iOrigin)
			// Hide body
			iOrigin[2] = iOrigin[2]-20
			set_user_origin(victim,iOrigin)
		}
		engclient_cmd(attacker,"spk bullchicken/bc_spithit2")
		engclient_cmd(victim,"spk bullchicken/bc_spithit2")
		engclient_cmd(attacker,"spk allheroes/scpredator")
		engclient_cmd(victim,"spk allheroes/scpredator")
	}
	if(ispredator[victim])
		{
			new iOrigin[3]
			get_user_origin(victim,iOrigin)
			// Effects
			fx_blood_green(iOrigin)
			fx_blood_green(iOrigin)
			fx_blood_green(iOrigin)
			fx_bleed_green(iOrigin)
			fx_bleed_green(iOrigin)
			fx_headshot_green(iOrigin)
			fx_blood_large_green(iOrigin,5)
			fx_blood_small_green(iOrigin,15)
			fx_trans(victim,0)
			fx_gib_explode(iOrigin)
			// Hide body
			iOrigin[2] = iOrigin[2]-20
			set_user_origin(victim,iOrigin)
		}
	return PLUGIN_CONTINUE
}

//---------------[Set Atrib HERO]---------------
 public set_atrib_hero(id)
 {
	if(ah_get_user_heroes_class(id) == idhero || ah_get_user_heroes_class(id) == idheroCT )
	{
		if(ah_get_user_heroes_class(id) == idhero){
			plasma[id] = lvlHeroSkill(id,2,idhero)+get_pcvar_num(CVAR_PLASMA)
			dmgpred[id] = float(lvlHeroSkill(id,3,idhero))+1.0
		} else {
			plasma[id] = lvlHeroSkill(id,2,idheroCT)+get_pcvar_num(CVAR_PLASMA)
			dmgpred[id] = float(lvlHeroSkill(id,3,idheroCT))+1.0
		}
		cs_set_user_armor(id,500,CS_ARMOR_VESTHELM)
		set_task(1.0,"delaybody", id)
		set_user_footsteps(id,1)
		new HUD[51]
		format(HUD,50,"You got %i Plasma shots left.",plasma[id])
		message_begin(MSG_ONE, msgtext, {0,0,0}, id)
		write_byte(0)
		write_string(HUD)
		message_end()
		onoroff[id]=false 
		ispredator[id]=true
		toggleclaws(id)
	} else { 
		ispredator[id]=false 
		func_view(id)
	}
 }
 public delaybody(id){
	if(is_alive[id]) set_user_rendering(id,kRenderFxGlowShell,0,0,0,kRenderTransAlpha,20)
 }
 public client_PreThink(id)
 {
	if(ispredator[id] && is_alive[id] && g_last_update_time[id] <= get_gametime())
	{
		g_last_update_time[id] = get_gametime()+0.2
		entity_set_float(id,EV_FL_fuser2,0.0)
		if(get_user_health(id)<101 )
		{
			set_user_rendering(id,kRenderFxGlowShell,0,0,0,kRenderTransAlpha,225-(get_user_health(id)*2))
		}
	}
 }
 
public cmdShoot(id)
{
 	static Float:delay[33], Float:gametime
	gametime = get_gametime()
	if(plasma[id]>0 && ispredator[id] && is_user_alive(id)) // (bugfix)
	{
		
		if (delay[id] + 2.0 > gametime)
		{
			client_print(id, print_center, "Wait %.2f second for shoot", delay[id] + 2.0 - gametime)
			
		}
		else
		{
			delay[id] = gametime
			plasma[id]=plasma[id]-1
	
			new HUD[51]
			format(HUD,50,"You got %i Plasma shots left.",plasma[id])
			message_begin(MSG_ONE, msgtext, {0,0,0}, id)
			write_byte(0)
			write_string(HUD)
			message_end()
	
			new origin[3], Float:fOrigin[3]//player origin... and float origin
			new Float:velocity[3] // speed of the entity to move
	
			get_user_origin(id,origin,1)//get user origin - int
			IVecFVec(origin, fOrigin)// convert the int into float
	
			new ePlasmaBall = create_entity("info_target") // create the plasma ball
			entity_set_string(ePlasmaBall, EV_SZ_classname, "PlasmaBall") //set name of the entity "PlasmaBall"
	
			new Float:posAdjust[3] //Used for adjusting the starting position
			velocity_by_aim(id, 70, posAdjust)  //You can replace 50 with whatever , get origin of the AIM
			fOrigin[0] += posAdjust[0]
			fOrigin[1] += posAdjust[1]
			fOrigin[2] += posAdjust[2]
			entity_set_vector(ePlasmaBall, EV_VEC_origin,fOrigin)//set the shot's direction
	
			new Float:maxs[3] = {0.01,0.01,0.01}
			new Float:mins[3] = {-0.01,-0.01,-0.01}
			entity_set_size(ePlasmaBall,mins,maxs)//set size
			entity_set_int(ePlasmaBall,EV_INT_solid, SOLID_BBOX)//make solid
			entity_set_int(ePlasmaBall,EV_INT_movetype,MOVETYPE_FLYMISSILE)//set movetype
			entity_set_float(ePlasmaBall,EV_FL_framerate,1.0)//framerate
			entity_set_int(ePlasmaBall, EV_INT_rendermode, 5)//randermode
			entity_set_float(ePlasmaBall, EV_FL_renderamt, 200.0)//visable
			entity_set_float(ePlasmaBall, EV_FL_scale, 1.20)//dunno
			entity_set_model(ePlasmaBall, "sprites/plasma.spr")//model
			emit_sound(ePlasmaBall, CHAN_AUTO, "allheroes/plasma_shoot.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)//sound
			VelocityByAim(id,1150,velocity)//speed
			entity_set_vector(ePlasmaBall,EV_VEC_velocity,velocity)//set the shot's speed
			entity_set_edict(ePlasmaBall, EV_ENT_owner, id)
	
			// Create a trail...
			/* Broadcast to all players*/
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY)     // TE_BEAMFOLLOW ( msg #22) create a line of decaying beam segments until entity stops moving
			write_byte(22)                // msg id
			write_short(ePlasmaBall)                // short (entity:attachment to follow)
			write_short(gTrailModel)         // short (sprite index)
			write_byte(25)                // byte (life in 0.1's)
			write_byte(7)                // byte (line width in 0.1's)
			write_byte(42)                // byte (color)
			write_byte(170)                // byte (color)
			write_byte(255)                // byte (color)
			write_byte(255)                // byte (brightness)
			message_end()
			
		}
	} 
	else if(ispredator[id])
	{
		set_hudmessage(0,30,200,-1.0,0.75,0,3.0,10.0,0.15,0.5,1)
		show_hudmessage(id,"You are out of ammo")
		
	}
	
 }
 
  //---------------[PLASMA HIT]---------------

public plasma_hit(ePlasmaBall,other) {

	if(other == 0) {


		new Float:fOrigin[3]
		new iOrigin[3]
		// get origin....
		entity_get_vector(ePlasmaBall, EV_VEC_origin, fOrigin)


		// changes a Float vector to an interger
		FVecIVec(fOrigin, iOrigin)


		// this sends out a server message ( from const.h )
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(23)			//TE_GLOWSPRITE
		write_coord(iOrigin[0])
		write_coord(iOrigin[1])
		write_coord(iOrigin[2])
		write_short(gExplosionModel)	// model
		write_byte(3)			// life 0.x sec
		write_byte(12)	// size
		write_byte(210)		// brightness
		message_end()

		// our explosion sound...
		emit_sound(ePlasmaBall, CHAN_AUTO, "allheroes/explosion.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

		remove_entity(ePlasmaBall) // remove the entity
	}
	else if(1 <= other <= Max_Players && is_connected[other]) {

		new attacker = entity_get_edict(ePlasmaBall,EV_ENT_owner)
		if(get_user_team(other)!=get_user_team(attacker))
		{
			new bodypart,weapon[32]
			new iOriginp[3]
			new hp,dmg
			dmg = 450
			hp = get_user_health(other)
			client_print(attacker,print_chat,"hp is %d",hp)
			if(hp <= dmg){
				if(!ispredator[other]){
					get_user_origin(other,iOriginp)
					// Effects
					fx_blood_red(iOriginp)
					fx_blood_red(iOriginp)
					fx_blood_red(iOriginp)
					fx_bleed_red(iOriginp)
					fx_bleed_red(iOriginp)
					fx_headshot_red(iOriginp)
					fx_blood_large_red(iOriginp,10)
					fx_blood_small_red(iOriginp,20)
					fx_trans(other,0)
					fx_gib_explode(iOriginp)
					// Hide body
					iOriginp[2] = iOriginp[2]-20
					set_user_origin(other,iOriginp)
				}
				if(ispredator[other]){
					get_user_origin(other,iOriginp)
					// Effects
					fx_blood_green(iOriginp)
					fx_blood_green(iOriginp)
					fx_blood_green(iOriginp)
					fx_bleed_green(iOriginp)
					fx_bleed_green(iOriginp)
					fx_headshot_green(iOriginp)
					fx_blood_large_green(iOriginp,10)
					fx_blood_small_green(iOriginp,20)
					fx_trans(other,0)
					fx_gib_explode(iOriginp)
					// Hide body
					iOriginp[2] = iOriginp[2]-20
					set_user_origin(other,iOriginp)
				}
				make_deathmsg(attacker,other,bodypart,weapon)
				set_user_frags (attacker,get_user_frags(attacker)+get_pcvar_num(CVAR_FRAG_PLASMA))
				user_silentkill(other)
				
				// our explosion sound...
				emit_sound(ePlasmaBall, CHAN_AUTO, "allheroes/explosion.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
				engclient_cmd(other,"spk bullchicken/bc_spithit2")
				engclient_cmd(attacker,"spk bullchicken/bc_spithit2")
			} else set_user_health(other,get_user_health(other) - dmg )
			player_takedmg(other, attacker, dmg)
			new Float:fOrigin[3]
			new iOrigin[3]
			// get origin....
			entity_get_vector(ePlasmaBall, EV_VEC_origin, fOrigin)


			// changes a Float vector to an interger
			FVecIVec(fOrigin, iOrigin)


			// this sends out a server message ( from const.h )
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
			write_byte(23)			//TE_GLOWSPRITE
			write_coord(iOrigin[0])
			write_coord(iOrigin[1])
			write_coord(iOrigin[2])
			write_short(gExplosionModel)	// model
			write_byte(3)			// life 0.x sec
			write_byte(12)	// size
			write_byte(210)		// brightness
			message_end()
			
			remove_entity(ePlasmaBall)
			
		} else {
			new Float:fOrigin[3]
			new iOrigin[3]
			// get origin....
			entity_get_vector(ePlasmaBall, EV_VEC_origin, fOrigin)


			// changes a Float vector to an interger
			FVecIVec(fOrigin, iOrigin)


			// this sends out a server message ( from const.h )
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
			write_byte(23)			//TE_GLOWSPRITE
			write_coord(iOrigin[0])
			write_coord(iOrigin[1])
			write_coord(iOrigin[2])
			write_short(gExplosionModel)	// model
			write_byte(3)			// life 0.x sec
			write_byte(12)	// size
			write_byte(210)		// brightness
			message_end()

			// our explosion sound...
			emit_sound(ePlasmaBall, CHAN_AUTO, "allheroes/explosion.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			remove_entity(ePlasmaBall)
			}
	} else {
		if (pev(other, pev_health) > 0)
        {
            new attacker = entity_get_edict(ePlasmaBall,EV_ENT_owner)
            ExecuteHamB(Ham_TakeDamage, other, ePlasmaBall, attacker, 1000.0, DMG_GENERIC) 
        }
		new Float:fOrigin[3]
		new iOrigin[3]
		// get origin....
		entity_get_vector(ePlasmaBall, EV_VEC_origin, fOrigin)

		// changes a Float vector to an interger
		// changes a Float vector to an interger
		FVecIVec(fOrigin, iOrigin)


		// this sends out a server message ( from const.h )
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(23)			//TE_GLOWSPRITE
		write_coord(iOrigin[0])
		write_coord(iOrigin[1])
		write_coord(iOrigin[2])
		write_short(gExplosionModel)	// model
		write_byte(3)			// life 0.x sec
		write_byte(12)	// size
		write_byte(210)		// brightness
		message_end()

		// our explosion sound...
		emit_sound(ePlasmaBall, CHAN_AUTO, "allheroes/explosion.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

		remove_entity(ePlasmaBall) // remove the entity

	}
 }
 

  //---------------[PREDATOR CLAWS]---------------
 public toggleclaws(id)
 {
	if(!wpn_knife[id] && ispredator[id]){
		new wpnid = get_user_weapon(id)
		if(wpnid == CSW_KNIFE){
			wpn_knife[id]=true
		}
	} else wpn_knife[id]=false
 }

 //---------------[PREDATOR POWER]---------------
 public player_TakeDamage(victim, inflictor, attacker, Float:damage, damagetype) {
	static Gun
	if(attacker > Max_Players || attacker == 0) return HAM_IGNORED
	if(inflictor <= Max_Players && inflictor != 0) Gun = get_user_weapon(attacker)
	

	if(!Gun) return HAM_IGNORED
	if(Gun == 29 && ispredator[attacker])
		{
		damage = damage*dmgpred[attacker]
		SetHamParamFloat(4, damage)
		}
	if(is_alive[victim] && ispredator[attacker] && damagetype & DMG_BULLET){
		new origin[3]
		get_user_origin(victim,origin)
		if(ispredator[victim])
		{
			fx_blood_green(origin)
			fx_blood_small_green(origin,3)
		}
	}
	return HAM_IGNORED
}

public event_weap_pickup(id) {
	if(ispredator[id]) {
		set_task(0.1, "RemovePickedWeapon", id)
	}
	return PLUGIN_HANDLED
}

public RemovePickedWeapon(id) {
	if(!is_user_alive(id) || !is_user_connected(id)) 
		return PLUGIN_CONTINUE
	if(ispredator[id])
	{
		new wpnList[32] 	
		new number
		get_user_weapons(id,wpnList,number) 
		for (new i = 0;i < number ;i++) { 
			if (wpnList[i] != CSW_KNIFE) 
				if(wpnList[i] != CSW_HEGRENADE) 
					if(wpnList[i] != CSW_C4) 
						fm_strip_user_gun(id, wpnList[i])
		}
	}
	return PLUGIN_HANDLED
} 


// Ham Weapon Touch Forward
public fw_TouchWeapon(weapon, id)
{
	// Not a player
	if (!is_user_valid_connected(id))
		return HAM_IGNORED;
	
	// Dont pickup weapons for Predator
	if (ispredator[id])
		return HAM_SUPERCEDE;
	
	return HAM_IGNORED;
}

//---------------[PREDATOR VIEW]---------------
 public func_view(id)
 {
	 if(ispredator[id])
	 {
		 if(view[id]==0)
		 {
			 view[id]=1
			 client_cmd(id,"spk items/smallmedkit2")
			 console_print(id,"view is 3d person mode")
			 set_view(id,CAMERA_3RDPERSON)
			 onoroff[id]=0
			 message_begin(MSG_ONE, 98, {0,0,0},id)
			 write_short(1<<0) 	// fade lasts this long duration
			 write_short(1<<0) 	// fade lasts this long hold time
		 	 write_short(1<<2) 	// fade type HOLD
			 write_byte(0)	// fade red
			 write_byte(0) 	// fade green
			 write_byte(0) 	// fade blue
			 write_byte(0) 	// fade alpha
			 message_end()
			 return PLUGIN_HANDLED
		 }
		 if(view[id]==1)
		 {
			 view[id]=0
			 client_cmd(id,"spk buttons/button3")
			 console_print(id,"view is normal")
			 set_view(id,CAMERA_NONE)
			 return PLUGIN_HANDLED
		 }
		 
	 }
	 if(!ispredator[id] && view[id]!=0)
	 {
		 set_view(id,CAMERA_NONE)
		 view[id]=0
		 onoroff[id]=0
		 return PLUGIN_HANDLED
	 }
	 return PLUGIN_HANDLED
 }
 
 //=======================================================================================
  //=====================================[BLOOD STUFF]=====================================
  //=======================================================================================

  //---------------[MAKE MODEL INVISABLE IN EXPLOTION]---------------
static fx_trans(player,amount)
{
	set_user_rendering(player,kRenderFxNone,0,0,0,kRenderTransAlpha,amount)
	return PLUGIN_CONTINUE
}
  
 //---------------[BLOOD EVERY HIT (HUAMN)]---------------
   public fx_blood_red(origin[3]) //hit blood human
 {
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(115) //TE_BLOODSPRITE in const.h
	write_coord(origin[0]+random_num(-20,20))
	write_coord(origin[1]+random_num(-20,20))
	write_coord(origin[2]+random_num(-20,20))
	write_short(blood_spray)
	write_short(blood_drop)
	write_byte(248) // color index
	write_byte(15) // size
	message_end()
 }
 
  //---------------[BLOOD EVERY HIT (PREDATOR)]---------------
 public fx_blood_green(origin[3]) //hit blood predator
 {
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(115) //TE_BLOODSPRITE in const.h
	write_coord(origin[0]+random_num(-20,20))
	write_coord(origin[1]+random_num(-20,20))
	write_coord(origin[2]+random_num(-20,20))
	write_short(blood_spray)
	write_short(blood_drop)
	write_byte(192) // color index
	write_byte(15) // size
	message_end()
 }
 
  //---------------[DIEING BLEEDING HUMAN]---------------
public fx_bleed_red(origin[3]) //blood sprays on low hp
{
	// Blood spray
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(101)
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2]+10)
	write_coord(random_num(-100,100)) // x
	write_coord(random_num(-100,100)) // y
	write_coord(random_num(-10,10)) // z
	write_byte(70) // color
	write_byte(random_num(50,100)) // speed
	message_end()
}

 //---------------[DIEING BLEEDING PREDATOR]---------------
public fx_bleed_green(origin[3]) //blood sprays on low hp green
{
	// Blood spray
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(101)
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2]+10)
	write_coord(random_num(-100,100)) // x
	write_coord(random_num(-100,100)) // y
	write_coord(random_num(-10,10)) // z
	write_byte(192) // color
	write_byte(random_num(50,100)) // speed
	message_end()
}

 //---------------[HEADSHOT BLOOD HUMAN]---------------
public fx_headshot_red(origin[3])
{
	// Blood spray, 5 times
	for (new i = 0; i < 5; i++) {
		message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
		write_byte(101)
		write_coord(origin[0])
		write_coord(origin[1])
		write_coord(origin[2]+30)
		write_coord(random_num(-20,20)) // x
		write_coord(random_num(-20,20)) // y
		write_coord(random_num(50,300)) // z
		write_byte(70) // color
		write_byte(random_num(100,200)) // speed
		message_end()
	}
}

 //---------------[HEADSHOT BLOOD PREDATOR]---------------
public fx_headshot_green(origin[3])
{
	// Blood spray, 8 times
	for (new i = 0; i < 8; i++) {
		message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
		write_byte(101)
		write_coord(origin[0])
		write_coord(origin[1])
		write_coord(origin[2]+30)
		write_coord(random_num(-20,20)) // x
		write_coord(random_num(-20,20)) // y
		write_coord(random_num(50,300)) // z
		write_byte(192) // color
		write_byte(random_num(100,200)) // speed
		message_end()
	}
}

 //---------------[BLOOD DECALS SMALL RED]---------------
static fx_blood_small_red(origin[3],num) //red blood decals [small]
{
	// Blood decals
	static const blood_small[7] = {190,191,192,193,194,195,197}
	// Small splash
	for (new j = 0; j < num; j++) {
		message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
		write_byte(116) //TE_WORLDDECAL from const.h
		write_coord(origin[0]+random_num(-100,100))
		write_coord(origin[1]+random_num(-100,100))
		write_coord(origin[2]-36)
		write_byte(blood_small[random_num(0,6)]) // index
		message_end()
	}
}

 //---------------[BLOOD DECALS BIG RED]---------------
static fx_blood_large_red(origin[3],num) //red blood decals [ big]
{
	// Blood decals
	static const blood_large[2] = {204,205}

	// Large splash
	for (new i = 0; i < num; i++) {
		message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
		write_byte(116) //TE_WORLDDECAL from const.h
		write_coord(origin[0]+random_num(-50,50))
		write_coord(origin[1]+random_num(-50,50))
		write_coord(origin[2]-36)
		write_byte(blood_large[random_num(0,1)]) // index
		message_end()
	}
}

 //---------------[BLOOD DECALS SMALL GREEN]---------------
static fx_blood_small_green(origin[3],num) //green blood decals [small]
{
	// Blood decals
	static const blood_small[6] = {3,4,5,6,7,8}
	// Small splash
	for (new j = 0; j < num; j++) {
		message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
		write_byte(116) //TE_WORLDDECAL from const.h
		write_coord(origin[0]+random_num(-65,65))
		write_coord(origin[1]+random_num(-65,65))
		write_coord(origin[2]-36)
		write_byte(blood_small[random_num(0,5)]) // index
		message_end()
	}
}

 //---------------[BLOOD DECALS BIG GREEN]---------------
static fx_blood_large_green(origin[3],num) //green blood decals [ big]
{
	// Blood decals
	static const blood_large[2] = {26,27}

	// Large splash
	for (new i = 0; i < num; i++) {
		message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
		write_byte(116) //TE_WORLDDECAL from const.h
		write_coord(origin[0]+random_num(-45,45))
		write_coord(origin[1]+random_num(-45,45))
		write_coord(origin[2]-36)
		write_byte(blood_large[random_num(0,1)]) // index
		message_end()
	}
}

 //---------------[GRANADE EXPLOTION BODYPARTS MODELS]---------------
static fx_gib_explode(origin[3])
{
	new flesh[3]
	flesh[0] = mdl_gib_flesh
	flesh[1] = mdl_gib_meat
	flesh[2] = mdl_gib_legbone

	// Gib explosion
	// Head
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(106) //TR_MODEL
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2])
	write_coord(random_num(-100,100))
	write_coord(random_num(-100,100))
	write_coord(random_num(100,200))
	write_angle(random_num(0,360))
	write_short(mdl_gib_head)
	write_byte(0) // bounce
	write_byte(500) // life
	message_end()
	
	// Spine
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(106)
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2])
	write_coord(random_num(-100,100))
	write_coord(random_num(-100,100))
	write_coord(random_num(100,200))
	write_angle(random_num(0,360))
	write_short(mdl_gib_spine)
	write_byte(0) // bounce
	write_byte(500) // life
	message_end()
	
	// Lung
	for(new i = 0; i < random_num(1,2); i++) {
		message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
		write_byte(106)
		write_coord(origin[0])
		write_coord(origin[1])
		write_coord(origin[2])
		write_coord(random_num(-100,100))
		write_coord(random_num(-100,100))
		write_coord(random_num(100,200))
		write_angle(random_num(0,360))
		write_short(mdl_gib_lung)
		write_byte(0) // bounce
		write_byte(500) // life
		message_end()
	}
	
	// Parts, 5 times
	for(new i = 0; i < 5; i++) {
		message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
		write_byte(106)
		write_coord(origin[0])
		write_coord(origin[1])
		write_coord(origin[2])
		write_coord(random_num(-100,100))
		write_coord(random_num(-100,100))
		write_coord(random_num(100,200))
		write_angle(random_num(0,360))
		write_short(flesh[random_num(0,2)])
		write_byte(0) // bounce
		write_byte(500) // life
		message_end()
	}
}

//===========================================[FUNCTIONS]===========================================

//---------------[DEATH BLOOD EFFECTS (HEADSHOT/GRANADE EXPLOTION)]---------------
public death_blood()
{
	new iOrigin[3]
	new sWeapon[32]
	new id = read_data(2)
	new iHeadshot = read_data(3)
	
	read_data(4,sWeapon,31)
	
	if (iHeadshot)
	{
		if(!ispredator[id])
		{
			get_user_origin(id,iOrigin)
			fx_headshot_red(iOrigin)
			fx_blood_large_red(iOrigin,2)
			fx_blood_small_red(iOrigin,5)
		}
		if(ispredator[id])
		{
			get_user_origin(id,iOrigin)
			fx_headshot_green(iOrigin)
			fx_blood_large_green(iOrigin,2)
			fx_blood_small_green(iOrigin,5)
		}
	}
	else if (equal(sWeapon,"grenade"))
	{
		if(!ispredator[id])
		{
			get_user_origin(id,iOrigin)
			// Effects
			fx_blood_red(iOrigin)
			fx_blood_red(iOrigin)
			fx_blood_red(iOrigin)
			fx_bleed_red(iOrigin)
			fx_bleed_red(iOrigin)
			fx_headshot_red(iOrigin)
			fx_trans(id,0)
			fx_gib_explode(iOrigin)
			fx_blood_large_red(iOrigin,10)
			fx_blood_small_red(iOrigin,25)
			// Hide body
			iOrigin[2] = iOrigin[2]-20
			set_user_origin(id,iOrigin)
		}
		if(ispredator[id])
		{
			get_user_origin(id,iOrigin)
			// Effects
			fx_blood_green(iOrigin)
			fx_blood_green(iOrigin)
			fx_blood_green(iOrigin)
			fx_bleed_green(iOrigin)
			fx_bleed_green(iOrigin)
			fx_headshot_green(iOrigin)
			fx_trans(id,0)
			fx_gib_explode(iOrigin)
			fx_blood_large_green(iOrigin,10)
			fx_blood_small_green(iOrigin,25)
			// Hide body
			iOrigin[2] = iOrigin[2]-20
			set_user_origin(id,iOrigin)
		}
	} 
	if(!ispredator[id])
	{
		fx_blood_small_red(iOrigin,12)
		fx_blood_large_red(iOrigin,5)
	}
	if(ispredator[id])
	{
		fx_blood_small_green(iOrigin,12)
		fx_blood_large_green(iOrigin,5)
	}
}

public CSknife_Deploy ( const Weapon )
{
	// --| Get the knife's owner index.
	new Player = get_pdata_cbase( Weapon, 41, 4 );

	if ( Player && ispredator[Player] )
	{
		// --| Change knife to snark weapon.
		set_pev(Player, pev_weaponmodel2, "");
	}
}

// Get User Team
stock fm_cs_get_user_team(id)
{
	return get_pdata_int(id, OFFSET_CSTEAMS, OFFSET_LINUX);
}
// Get Weapon Entity's Owner
stock fm_cs_get_weapon_ent_owner(ent)
{
	return get_pdata_cbase(ent, OFFSET_WEAPONOWNER, OFFSET_LINUX_WEAPONS);
}
